

# ListDimensions
<a name="API_ListDimensions"></a>

**Note**  
The Amazon IoT Device Defender detect feature will no longer be available to new customers starting August 31, 2026. If you would like to use the detect feature, sign up prior to August 31, 2026. To learn about alternatives to Amazon IoT Device Defender detect, see [Amazon IoT Device Defender detect feature availability change](https://docs.amazonaws.cn/iot-device-defender/latest/devguide/dd-detect-availability-change.html). There is no change to Amazon IoT Device Defender audit availability.

List the set of dimensions that are defined for your Amazon Web Services accounts.

Requires permission to access the [ListDimensions](https://docs.amazonaws.cn/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_ListDimensions_RequestSyntax"></a>

```
GET /dimensions?maxResults={{maxResults}}&nextToken={{nextToken}} HTTP/1.1
```

## URI Request Parameters
<a name="API_ListDimensions_RequestParameters"></a>

The request uses the following URI parameters.

 ** [maxResults](#API_ListDimensions_RequestSyntax) **   <a name="iot-ListDimensions-request-uri-maxResults"></a>
The maximum number of results to retrieve at one time.  
Valid Range: Minimum value of 1. Maximum value of 250.

 ** [nextToken](#API_ListDimensions_RequestSyntax) **   <a name="iot-ListDimensions-request-uri-nextToken"></a>
The token for the next set of results.

## Request Body
<a name="API_ListDimensions_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListDimensions_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "dimensionNames": [ "string" ],
   "nextToken": "string"
}
```

## Response Elements
<a name="API_ListDimensions_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [dimensionNames](#API_ListDimensions_ResponseSyntax) **   <a name="iot-ListDimensions-response-dimensionNames"></a>
A list of the names of the defined dimensions. Use `DescribeDimension` to get details for a dimension.  
Type: Array of strings  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `[a-zA-Z0-9:_-]+` 

 ** [nextToken](#API_ListDimensions_ResponseSyntax) **   <a name="iot-ListDimensions-response-nextToken"></a>
A token that can be used to retrieve the next set of results, or `null` if there are no additional results.  
Type: String

## Errors
<a name="API_ListDimensions_Errors"></a>

 ** InternalFailureException **   
An unexpected error has occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request is not valid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ThrottlingException **   
The rate exceeds the limit.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

## See Also
<a name="API_ListDimensions_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for C\+\+](https://docs.amazonaws.cn/goto/SdkForCpp/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for Python (Boto3)](https://docs.amazonaws.cn/goto/boto3/iot-2015-05-28/ListDimensions) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/iot-2015-05-28/ListDimensions) 